//+------------------------------------------------------------------+
//|                                                     Renko_v2.mq5 |
//|                           Copyright  2005, TrendLaboratory Ltd. |
//|                                       E-mail: igorad2004@list.ru |
//|                                            Many Thanks To Konkop |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, TrendLaboratory Ltd."
#property link      "E-mail: igorad2004@list.ru"
//---   
#property version   "1.00"
//---     
#property indicator_chart_window
//---        
#property indicator_buffers 7
//---    
#property indicator_plots   4
//+----------------------------------------------+
//|     1            |
//+----------------------------------------------+
//---      
#property indicator_type1   DRAW_FILLING
//---      Lavender 
#property indicator_color1  clrLavender
//---   
#property indicator_label1  "Renko_v2"
//+----------------------------------------------+
//|     2            |
//+----------------------------------------------+
//---   2   
#property indicator_type2   DRAW_LINE
//---        BlueViolet 
#property indicator_color2  clrBlueViolet
//---   2 -  
#property indicator_style2  STYLE_SOLID
//---    2  2
#property indicator_width2  2
//---    
#property indicator_label2  "Upper Renko"
//+----------------------------------------------+
//|     3            |
//+----------------------------------------------+
//---   3   
#property indicator_type3   DRAW_LINE
//---        Magenta 
#property indicator_color3  clrMagenta
//---   3 -  
#property indicator_style3  STYLE_SOLID
//---    3  2
#property indicator_width3  2
//---    
#property indicator_label3  "Lower Renko"
//+----------------------------------------------+
//|     4            |
//+----------------------------------------------+
//---      
#property indicator_type4 DRAW_COLOR_HISTOGRAM2
//---      
#property indicator_color4 clrRed,clrPurple,clrGray,clrTeal,clrLime
//---   - 
#property indicator_style4 STYLE_SOLID
//---     2
#property indicator_width4 2
//---   
#property indicator_label4 "Renko_BARS"
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input uint PeriodATR=10;
input double Katr=1.00;
input uint   Shift=1;   //       
//+----------------------------------------------+
//---   ,   
//---      
double Up1Buffer[],Dn1Buffer[];
double Up2Buffer[],Dn2Buffer[];
double UpIndBuffer[],DnIndBuffer[],ColorIndBuffer[];
//---      
int min_rates_total;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
void OnInit()
  {
//---     
   min_rates_total=int(PeriodATR+Shift);
//---      
   SetIndexBuffer(0,Up1Buffer,INDICATOR_DATA);
//---       
   ArraySetAsSeries(Up1Buffer,true);
//---      
   SetIndexBuffer(1,Dn1Buffer,INDICATOR_DATA);
//---       
   ArraySetAsSeries(Dn1Buffer,true);
//---      
   SetIndexBuffer(2,Up2Buffer,INDICATOR_DATA);
//---       
   ArraySetAsSeries(Up2Buffer,true);
//---      
   SetIndexBuffer(3,Dn2Buffer,INDICATOR_DATA);
//---       
   ArraySetAsSeries(Dn2Buffer,true);
//---    IndBuffer   
   SetIndexBuffer(4,UpIndBuffer,INDICATOR_DATA);
//---       
   ArraySetAsSeries(UpIndBuffer,true);
//---    IndBuffer   
   SetIndexBuffer(5,DnIndBuffer,INDICATOR_DATA);
//---       
   ArraySetAsSeries(DnIndBuffer,true);
//---          
   SetIndexBuffer(6,ColorIndBuffer,INDICATOR_COLOR_INDEX);
//---       
   ArraySetAsSeries(ColorIndBuffer,true);
//---    1    Shift
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//---       1  min_rates_total
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//---    2    Shift
   PlotIndexSetInteger(1,PLOT_SHIFT,Shift);
//---       2  min_rates_total
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//---    3    Shift
   PlotIndexSetInteger(2,PLOT_SHIFT,Shift);
//---       3  min_rates_total
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,min_rates_total);
//---    3    Shift
   PlotIndexSetInteger(3,PLOT_SHIFT,0);
//---       4  min_rates_total
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,min_rates_total);
//---   ,      
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,0);
//---      
   string shortname;
   StringConcatenate(shortname,"Renko(",PeriodATR,", ",DoubleToString(Katr,4),", ",Shift,")");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//---
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &Open[],
                const double& High[],     //       
                const double& Low[],      //        
                const double &Close[],
                const long &Tick_Volume[],
                const long &Volume[],
                const int &Spread[])
  {
//---       
   if(rates_total<min_rates_total) return(0);
//---    
   int limit;
   double Up,Dn,Brick,AvgRange,dK,ATR;
   static double Up_,Dn_,Brick_;
//---    limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
     {
      limit=rates_total-min_rates_total-1; //      
      Up_=High[limit];
      Dn_=Low[limit];
      Brick_=Katr*(High[limit]-Low[limit]);
     }
   else limit=rates_total-prev_calculated; //      
//---       
   ArraySetAsSeries(Close,true);
   ArraySetAsSeries(Open,true);
   ArraySetAsSeries(High,true);
   ArraySetAsSeries(Low,true);
//---   
   Up=Up_;
   Dn=Dn_;
   Brick=Brick_;
//---    
   for(int bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      AvgRange=0;
      for(int iii=int(PeriodATR-1); iii>=0; iii--)
        {
         dK=1;
         AvgRange+=dK*MathAbs(High[bar+iii]-Low[bar+iii]);
        }
      ATR=AvgRange/PeriodATR;

      if(Close[bar]>Up+Brick)
        {
         if(Brick) Up+=MathRound((Close[bar]-Up)/Brick)*Brick;
         Brick=Katr*ATR;
         Dn=Up-Brick;
        }

      if(Close[bar]<Dn-Brick)
        {
         if(Brick) Dn-=MathRound((Dn-Close[bar])/Brick)*Brick;
         Brick=Katr*ATR;
         Up=Dn+Brick;
        }
      //---
      Up1Buffer[bar]=Up;
      Dn1Buffer[bar]=Dn;
      //---
      Up2Buffer[bar]=Up;
      Dn2Buffer[bar]=Dn;
      //---   
      if(bar)
        {
         Up_=Up;
         Dn_=Dn;
         Brick_=Brick;
        }
     }
//---    limit    
   if(prev_calculated>rates_total || prev_calculated<=0) limit-=int(Shift);
//---     
   for(int bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      int clr=2;
      UpIndBuffer[bar]=0.0;
      DnIndBuffer[bar]=0.0;

      if(Close[bar]>Up1Buffer[bar+Shift])
        {
         if(Open[bar]<Close[bar]) clr=4;
         else clr=3;
         UpIndBuffer[bar]=High[bar];
         DnIndBuffer[bar]=Low[bar];
        }
      //---
      if(Close[bar]<Dn1Buffer[bar+Shift])
        {
         if(Open[bar]>Close[bar]) clr=0;
         else clr=1;
         UpIndBuffer[bar]=High[bar];
         DnIndBuffer[bar]=Low[bar];
        }
      ColorIndBuffer[bar]=clr;
     }
//---     
   return(rates_total);
  }
//+------------------------------------------------------------------+
